'use client';
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var AsyncStateNavigator_js_1 = __importDefault(require("./AsyncStateNavigator.js"));
var NavigationContext_js_1 = __importDefault(require("./NavigationContext.js"));
var SceneRSCContext_js_1 = __importDefault(require("./SceneRSCContext.js"));
var NavigationHandler = /** @class */ (function (_super) {
    __extends(NavigationHandler, _super);
    function NavigationHandler(props) {
        var _this = _super.call(this, props) || this;
        var stateNavigator = _this.props.stateNavigator;
        var _a = stateNavigator.stateContext, oldState = _a.oldState, state = _a.state, data = _a.data, asyncData = _a.asyncData;
        var asyncNavigator = new AsyncStateNavigator_js_1.default(_this, stateNavigator, stateNavigator.stateContext);
        _this.state = { context: { oldState: oldState, state: state, data: data, asyncData: asyncData, stateNavigator: asyncNavigator } };
        _this.onNavigate = _this.onNavigate.bind(_this);
        _this.refetch = _this.refetch.bind(_this);
        return _this;
    }
    NavigationHandler.prototype.componentDidMount = function () {
        this.props.stateNavigator.onNavigate(this.onNavigate);
    };
    NavigationHandler.prototype.componentWillUnmount = function () {
        this.props.stateNavigator.offNavigate(this.onNavigate);
    };
    NavigationHandler.prototype.onNavigate = function () {
        var stateNavigator = this.props.stateNavigator;
        var stateContext = stateNavigator.stateContext;
        if (this.state.context.stateNavigator.stateContext !== stateContext) {
            var oldState = stateContext.oldState, state = stateContext.state, data = stateContext.data, asyncData = stateContext.asyncData;
            var asyncNavigator = new AsyncStateNavigator_js_1.default(this, stateNavigator, stateContext);
            this.setState({ context: { oldState: oldState, state: state, data: data, asyncData: asyncData, stateNavigator: asyncNavigator } });
        }
    };
    NavigationHandler.prototype.refetch = function () {
        var _this = this;
        (0, react_1.startTransition)(function () {
            _this.setState({ context: __assign(__assign({}, _this.state.context), { ignoreCache: true }) });
        });
    };
    NavigationHandler.prototype.render = function () {
        return (react_1.default.createElement(NavigationContext_js_1.default.Provider, { value: this.state.context },
            react_1.default.createElement(SceneRSCContext_js_1.default.Provider, { value: this.refetch }, this.props.children)));
    };
    return NavigationHandler;
}(react_1.Component));
exports.default = NavigationHandler;
